//
//  effi. prog. - oop in c
//

#include <stdlib.h>
#include <string.h>
#include "String.h"
#include "root.h"


static void * String_ctor (void * _self, va_list * arg_list)
{
    StringType * self = _self;
	const char * text = va_arg(* arg_list, const char *);
	self -> text = malloc(strlen(text) + 1);
	strcpy(self -> text, text);
	return self;
}

static void * String_dtor (void * _self)
{
    StringType * self = _self;
	free(self -> text), self -> text = 0;
	return self;
}

static void * String_clone (void * _self)
{
	StringType * self = _self;
	return new(String, self -> text);
}

//generic part, for polymorph functionality
static Class _String = {
	sizeof(StringType),
	String_ctor,
    String_dtor,
	String_clone
};

//class pointer
void * String = & _String;
